#include <Au3SyntaxHighlight.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <IE.au3>

$iAu3SH_AddURLs = 1

$sInitDir = ''
$sFilter = '*.au3'

$sMRUList = RegRead('HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\ComDlg32\OpenSaveMRU\au3', 'MRUList')
$sLastFileOpenPath = RegRead('HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\ComDlg32\OpenSaveMRU\au3', StringLeft($sMRUList, 1))

If Not FileExists($sLastFileOpenPath) Then
	$sInitDir = @ScriptDir
	$sFilter = 'Test Script.au3'
EndIf

$sFile = FileOpenDialog('Open Au3 Script File', $sInitDir, 'AutoIt Script (' & $sFilter & ')')
If @error Then Exit

$sAu3Code = FileRead($sFile)
$sAu3Syntax_HighlightedCode = _Au3_SyntaxHighlight_Proc($sAu3Code, 0)

$sTmp_File = @TempDir & '\Au3_HighlightSyntax.htm'

$hFile = FileOpen($sTmp_File, 2)
FileWrite($hFile, $sAu3Syntax_HighlightedCode)
FileClose($hFile)

Execute('_IEErrorHandlerRegister()')

$oIE = _IECreateEmbedded()

$iGUI_Width = @DesktopWidth - 40
$iGUI_Height = @DesktopHeight - 150

$hGUI = GUICreate('AutoIt Syntax Highlighter [' & $sFile & ']', $iGUI_Width, $iGUI_Height, -1, -1, BitOR($GUI_SS_DEFAULT_GUI, $WS_CLIPSIBLINGS, $WS_CLIPCHILDREN))
GUICtrlCreateObj($oIE, 10, 20, $iGUI_Width - 20, $iGUI_Height - 70)
$iBack_Bttn = GUICtrlCreateButton('Back', 10, $iGUI_Height - 40, 100, 30)
$iForward_Bttn = GUICtrlCreateButton('Forward', 120, $iGUI_Height - 40, 100, 30)
$iHome_Bttn = GUICtrlCreateButton('Home', 230, $iGUI_Height - 40, 100, 30)
$iStop_Bttn = GUICtrlCreateButton('Stop', 340, $iGUI_Height - 40, 100, 30)

GUISetState(@SW_SHOW, $hGUI)

_IENavigate($oIE, $sTmp_File)

While 1
    Switch GUIGetMsg()
		Case $GUI_EVENT_CLOSE
			GUIDelete($hGUI)
            Exit
		Case $iHome_Bttn
            _IENavigate($oIE, $sTmp_File)
        Case $iBack_Bttn
            _IEAction($oIE, 'back')
        Case $iForward_Bttn
            _IEAction($oIE, 'forward')
        Case $iStop_Bttn
            _IEAction($oIE, 'stop')
    EndSwitch
WEnd
